	.ORIG x0000

BOOT_ROM
	CONST R0, 255
	MUL R0, R0, R0
	INC R0, 10	;R0 = LBA0_ADDR = xFE0B

	INC R4, 1	;IF R4 = -1, THIS IS A CALL TO LOAD A PROGRAM
	BRnp R4, READ_PARTITION_TABLE
	JUMP LOAD_PROGRAM
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;READ FAT16 FS TO FIND THE LBA OF THE RAMIMAGE FILE;;;;;
;;;;       THIS SETS R1 TO LBA0 AND R2 TO LBA1        ;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	
READ_PARTITION_TABLE
	;READ THE PARTITON TABLE
	CONST R1, 0
	CONST R6, 1	;R6 = CF_READ_INIT Signal = 1
	STR R1, R0, 0	;WRITE 0 TO LBA0
	STR R1, R0, 1	;WRITE 0 TO LBA1
	STR R6, R0, 3	;INIT CF READ
PARTITION_POLL
	LDR R4, R0, 3	;READ CF_STATUS
	BRzp R4, PARTITION_POLL
	
	;THE LBA FOR THE FIRST PARTITION'S BOOT SECTOR LIES AT OFFSET xE3 = 227
	CONST R2, xE3
	STR R2, R0, 2	;WRITE xE3 TO CF_OFFSET
	JSR GET_CF_WORD	;R2 = BOOT SECTOR LBA0
	STR R2, R0, 0	;WRITE LBA0
	JSR GET_CF_WORD	;R2 = BOOT_SECTOR LBA1
	STR R2, R0, 1	;WRITE LBA1
	
	;READ THE BOOT SECTOR
	STR R6, R0, 3	;INIT CF READ
BOOT_SECTOR_POLL
	LDR R4, R0, 3	;READ CF_STATUS
	BRzp R4, BOOT_SECTOR_POLL
	
	;THE NUMBER OF SECTORS PER CLUSTER LIES AT BYTE 2 OF OFFSET 6
	CONST R2, 6
	STR R2, R0, 2	;WRITE 6 TO CF_OFFSET
	LDR R6, R0, 4	;READ CF_DATA
	CONST R2, xFF
	AND R6, R6, R2	;R6 = SECTORS PER CLUSTER
	
	;NUMBER OF RESERVED SECTORS LIES AT OFFSET 7
	CONST R5, 0
	JSR GET_CF_WORD
	ADD R1, R2, R5	;R1 = RESERVED SECTORS
	
	;NUMBER OF FATS LIES AT BYTE 1 OF OFFSET 8
	;NUMBER OF ROOT ENTIRES LIES AT OFFSET 8.5
	LDR R3, R0, 4	;READ CF_DATA
	CONST R2, xFF
	AND R5, R3, R2	;R5 = LOW-ORDER BYTE OF ROOT_DIR_ENTRIES
	CONST R7, 8
	SRL R3, R3, R7	;R3 = NUMBER OF FATS
	LDR R2, R0, 4	;READ CF_DATA
	SRL R2, R2, R7
	SLL R2, R2, R7
	OR R5, R5, R2	;R5 = ROOT_DIR_ENTRIES
	CONST R7, 4
	SRL R5, R5, R7	;R5 = ROOT_DIR_SECTORS = ROOT_DIR_ENTRIES / 16
	
	;SECTORS PER FAT LIES AT OFFSET 11
	CONST R7, 11
	STR R7, R0, 2	;WRITE 11 TO OFFSET
	LDR R2, R0, 4	;R2 HAS LITTLE_ENDIAN SECTORS PER FAT
	CONST R4, 8	;MAKE R2 BIG-ENDIAN
	SRL R7, R2, R4
	SLL R2, R2, R4
	OR R2, R2, R7	;R2 = SECTORS PER FAT
	
	;ADDRESS OF THE ROOT DIRECTORY IS CURRENT LBA + RESERVED SECTORS + NUMBER OF FATS * SECTORS PER FAT
	MUL R3, R3, R2	;R3 = NUMBER OF FATS * SECTORS PER FAT
	ADD R3, R3, R1	;R3 = OFFSET (IN SECTORS) TO ROOT DIRECTORY
	LDR R1, R0, 0	;R1 = CURRENT LBA0
	LDR R2, R0, 1	;R2 = CURRENT LBA1
	ADD R3, R1, R3	;R3 = NEW LBA0
	SUB R4, R3, R1
	BRzp R4, RD_LBA_NO_OVERFLOW
	INC R2, 1		;IF LBA0 OVERFLOWED, INCREMENT LBA1
RD_LBA_NO_OVERFLOW
	;SET THE LBA FOR THE ROOT DIRECTORY
	STR R3, R0, 0
	STR R2, R0, 1
	
	;READ THE ROOT DIRECTORY
	CONST R4, 8

	;R5 HOLDS THE NUMBER OF SECTORS TO PROCESS
READ_ROOT_DIRECTORY
	STR R6, R0, 3	;INIT CF READ 
READ_ROOT_DIR_POLL
	LDR R2, R0, 3
	BRzp R2, READ_ROOT_DIR_POLL

	CONST R2, 0
	STR R2, R0, 2	;SET CF OFFSET TO 0
	CONST R1, 16	;EACH SECTOR HAS 16 DIRECTORY ENTRIES
READ_FILE_ENTRY
	BRnp R1, SAME_SECTOR
	JUMP GET_NEXT_SECTOR
SAME_SECTOR
	;SEE IF THE FIRST WORD IS "RA" = x5241
	LDR R2, R0, 4
	CONST R3, x52
	SLL R3, R3, R4
	INC R3, x41	;R3 = x5241
	SUB R3, R2, R3
	BRnp R3, NO_MATCH_1

	;SEE IF THE SECOND WORD IS "MI" = x4D49		
	LDR R2, R0, 4
	CONST R3, x4D
	SLL R3, R3, R4
	INC R3, x49	;R3 = x4D49
	SUB R3, R2, R3
	BRnp R3, NO_MATCH_2

	;SEE IF THE THIRD WORD IS "MA" = x4D41		
	LDR R2, R0, 4
	CONST R3, x4D
	SLL R3, R3, R4
	INC R3, x41	;R3 = x4D41
	SUB R3, R2, R3
	BRnp R3, NO_MATCH_3

	;SEE IF THE FOURTH WORD IS "GE" = x4745		
	LDR R2, R0, 4
	CONST R3, x47
	SLL R3, R3, R4
	INC R3, x45	;R3 = x4745
	SUB R3, R2, R3
	BRnp R3, NO_MATCH_4	

	;THE RAMIMAGE ENTRY HAS BEEN FOUND
	JUMP SET_RAMIMAGE_LBA

NO_MATCH_1
	LDR R2, R0, 2	;R2 = OFFSET
	INC R2, 15
	STR R2, R0, 2	;INCREMENT THE OFFSET TO POINT TO THE NEXT FILE ENTRY
	JUMP NEXT_ENTRY
NO_MATCH_2
	LDR R2, R0, 2	;R2 = OFFSET
	INC R2, 14
	STR R2, R0, 2	;INCREMENT THE OFFSET TO POINT TO THE NEXT FILE ENTRY
	JUMP NEXT_ENTRY
NO_MATCH_3
	LDR R2, R0, 2	;R2 = OFFSET
	INC R2, 13
	STR R2, R0, 2	;INCREMENT THE OFFSET TO POINT TO THE NEXT FILE ENTRY
	JUMP NEXT_ENTRY
NO_MATCH_4
	LDR R2, R0, 2	;R2 = OFFSET
	INC R2, 12
	STR R2, R0, 2	;INCREMENT THE OFFSET TO POINT TO THE NEXT FILE ENTRY
NEXT_ENTRY
	INC R1,	-1
	JUMP READ_FILE_ENTRY

GET_NEXT_SECTOR
	LDR R1, R0, 0	;R1 = LBA0
	INC R1, 1
	STR R1, R0, 0	;INCREMENT LBA0
	BRnp R1, RRD_NO_OVERFLOW
	LDR R2, R0, 1	;R2 = LBA0
	INC R2, 1
	STR R2, R0, 1	;IF OVERFLOW IN LBA0, INCREMENT LBA1
RRD_NO_OVERFLOW
	INC R5, -1
	BRz R5, END_OF_DIRECTORY
	JUMP READ_ROOT_DIRECTORY

SET_RAMIMAGE_LBA
	LDR R2, R0, 2	;R2 = CF_OFFSET
	INC R2, 9
	STR R2, R0, 2	;SET OFFSET TO RAMIMAGE STARTING CLUSTER
	JSR GET_CF_WORD	;R2 = RAMIMAGE STARTING CLUSTER
	INC R2, -2
	MUL R2, R2, R6
	ADD R3, R2, R5	;R3 = OFFSET TO RAMIMAGE SECTOR

	;SET RAMIMAGE LBA
	LDR R2, R0, 0	
	ADD R1, R2, R3	;R1 = LBA0
	SUB R4, R1, R2
	CONST R3, 255
	MUL R3, R3, R3
	INC R3, -1	;R3 = xFE00
	LDR R2, R0, 1	;R2 = LBA1
	BRp R4, LOAD_PROGRAM
	INC R2, 1
	JUMP LOAD_PROGRAM

END_OF_DIRECTORY
	HALT


;;;;;;;;;;;;;;;;;;;;;;
;R0 = xFE0B          ;
;R1 = OBJ FILE_LBA0  ;
;R2 = OBJ FILE_LBA1  ;
;R3 = WORDS TO COPY  ;
;;;;;;;;;;;;;;;;;;;;;;
LOAD_PROGRAM
	CONST R6, -1
LOAD_LOOP	
	STR R1, R0, 0	;WRITE LBA0
	STR R2, R0, 1	;WRITE LBA1
	CONST R4, 0
	STR R4, R0, 2	;SET CF_OFFSET TO 0
	INC R4, 1
	STR R4, R0, 3	;Initiate CF Read
CF_POLL
	LDR R4, R0, 3	;Read CF_Status
	BRzp R4, CF_POLL
	
	CONST R4, 16
	MUL R4, R4, R4	;R4 = Words per sector = 256

	CONST R5, 1	;IF this is the first sector of the file, read the starting mem addr
	ADD R5, R5, R6
	BRnp R5, COPY_SECTOR

	LDR R6, R0, 4	;Read starting mem addr from the .obj file
	INC R3, -1
	INC R4, -1 

COPY_SECTOR
	BRz R4, NEXT_ITERATION
	LDR R5, R0, 4	;Read word from CF buffer
	STR R5, R6, 0	;Write CF data to memory
	INC R6, 1
	INC R4, -1
	INC R3, -1
	BRz R3, SWITCH_TO_RAM
	JUMP COPY_SECTOR
NEXT_ITERATION
	INC R1, 1
	BRnp R1, LBA1_NO_INC
	INC R2, 1
LBA1_NO_INC
	JUMP LOAD_LOOP

SWITCH_TO_RAM
	LDR R1, R0, -6
	BRz R1, SWITCH_TO_RAM
	CONST R1, 22
	MUL R1, R1, R1
	INC R1, 28	;R1 = x200
	JUMPR R1
	
;SUBROUTINE TO GET A BIG-ENDIAN WORD FROM THE CF BUFFER
;THE OFFSET MUST BE SET BEFORE CALLING THIS ROUTINE
;INPUTS - R0 = xFE0B, R7 = RET ADDR
;OUTPUT - R2
;DESTROYS - R3, R4
GET_CF_WORD
	LDR R2, R0, 4	;R2 HAS DATA (LITTLE-ENDIAN)
	CONST R4, 8	;MAKE R2 BIG-ENDIAN
	SRL R3, R2, R4
	SLL R2, R2, R4
	OR R2, R2, R3	
	JUMPR R7

